/* ****************************************************************************
 * Copyright (C) 2016 Maxim Integrated Products, Inc., All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL MAXIM INTEGRATED BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Maxim Integrated
 * Products, Inc. shall not be used except as stated in the Maxim Integrated
 * Products, Inc. Branding Policy.
 *
 * The mere transfer of this software does not imply any licenses
 * of trade secrets, proprietary technology, copyrights, patents,
 * trademarks, maskwork rights, or any other form of intellectual
 * property whatsoever. Maxim Integrated Products, Inc. retains all
 * ownership rights.
 *
 * $Date: 2016-10-10 15:10:41 -0500 (Mon, 10 Oct 2016) $
 * $Revision: 24650 $
 *
 *************************************************************************** */

/* **** Includes **** */
#include <stddef.h>
#include "mxc_device.h"
#include "mxc_errors.h"
#include "mxc_assert.h"
#include "mxc_sys.h"
#include "gpio.h"
#include "mxc_pins.h"
#include "gcr_regs.h"
#include "fcr_regs.h"
#include "tmr_regs.h"
#include "flc_regs.h"
#include "icc_regs.h"
#include "bbfc_regs.h"
#include "mxc_delay.h"
#include "rtc.h"
#include "flc.h"
#include "pwrseq_regs.h"

/* **** Definitions **** */
#define SYS_CLOCK_TIMEOUT       MXC_DELAY_MSEC(1)

#define SYS_RTC_CLK 32768UL

/* **** Globals **** */

/* Symbol defined when loading RISCV image */
extern uint32_t _binary_riscv_bin_start;

/* **** Functions **** */

/* ************************************************************************** */
int MXC_SYS_GetUSN(uint8_t *usn, uint8_t *checksum) {
    return E_NOT_SUPPORTED;
    // TODO: Finish function
    // uint32_t *infoblock = (uint32_t*)MXC_INFO0_MEM_BASE;

    // /* Read the USN from the info block */
    // MXC_FLC_UnlockInfoBlock(MXC_INFO0_MEM_BASE);

    // memset(usn, 0, MXC_SYS_USN_CHECKSUM_LEN);

    // usn[0]  = (infoblock[0] & 0x007F8000) >> 15;
    // usn[1]  = (infoblock[0] & 0x7F800000) >> 23;
    // usn[2]  = (infoblock[1] & 0x0000007F) << 1;
    // usn[2] |= (infoblock[0] & 0x80000000) >> 31;
    // usn[3]  = (infoblock[1] & 0x00007F80) >> 7;
    // usn[4]  = (infoblock[1] & 0x007F8000) >> 15;
    // usn[5]  = (infoblock[1] & 0x7F800000) >> 23;
    // usn[6]  = (infoblock[2] & 0x007F8000) >> 15;
    // usn[7]  = (infoblock[2] & 0x7F800000) >> 23;
    // usn[8]  = (infoblock[3] & 0x0000007F) << 1;
    // usn[8] |= (infoblock[2] & 0x80000000) >> 31;
    // usn[9]  = (infoblock[3] & 0x00007F80) >> 7;
    // usn[10] = (infoblock[3] & 0x007F8000) >> 15;

    // // Compute the checksum
    // if(checksum != NULL) {
    //     uint8_t info_checksum[2];
    //     uint8_t key[MXC_SYS_USN_CHECKSUM_LEN];
    //     int i;

    //     /* Initialize the remainder of the USN and key */
    //     memset(key, 0, MXC_SYS_USN_CHECKSUM_LEN);
    //     memset(checksum, 0, MXC_SYS_USN_CHECKSUM_LEN);

    //     /* Read the checksum from the info block */
    //     info_checksum[0] = ((infoblock[3] & 0x7F800000) >> 23);
    //     info_checksum[1] = ((infoblock[4] & 0x007F8000) >> 15);

    //     /* Byte swap the USN for the checksum verification */
    //     uint8_t temp[MXC_SYS_USN_CHECKSUM_LEN];
    //     for(i = 0; i < MXC_SYS_USN_CHECKSUM_LEN; i++) {
    //         temp[i] = usn[MXC_SYS_USN_CHECKSUM_LEN-1-i];
    //     }

    //     /* Setup the encryption parameters */
    //     MXC_AES_Init();

    //     mxc_aes_req_t aesReq;
    //     aesReq.length = MXC_SYS_USN_CHECKSUM_LEN/4;
    //     aesReq.inputData = (uint32_t*)temp;
    //     aesReq.resultData = (uint32_t*)checksum;
    //     aesReq.keySize = MXC_AES_128BITS;
    //     aesReq.encryption = MXC_AES_ENCRYPT_EXT_KEY;

    //     MXC_AES_SetExtKey(key, MXC_AES_128BITS);
    //     MXC_AES_Encrypt(&aesReq);
    //     MXC_AES_Shutdown();

    //     /* Verify the checksum */
    //     if((checksum[MXC_SYS_USN_CHECKSUM_LEN-1] != info_checksum[1]) ||
    //         (checksum[MXC_SYS_USN_CHECKSUM_LEN-2] != info_checksum[0])) {

    //         MXC_FLC_LockInfoBlock(MXC_INFO0_MEM_BASE);
    //         return E_UNKNOWN;
    //     }
    // }

    // /* Add the info block checksum to the USN */
    // usn[11] = ((infoblock[3] & 0x7F800000) >> 23);
    // usn[12] = ((infoblock[4] & 0x007F8000) >> 15);

    // MXC_FLC_LockInfoBlock(MXC_INFO0_MEM_BASE);

    // return E_NO_ERROR;
}

/* ************************************************************************** */
int MXC_SYS_IsClockEnabled(mxc_sys_periph_clock_t clock)
{
    /* The sys_periph_clock_t enum uses enum values that are the offset by 32 for the perckcn1 register. */
    if (clock > 31) {
        clock -= 32;
        return !(MXC_GCR->perckcn1 & (0x1 << clock));
    } else {
        return !(MXC_GCR->perckcn & (0x1 << clock));
    }
}

/* ************************************************************************** */
int MXC_SYS_ClockDisable(mxc_sys_periph_clock_t clock)
{
    /* The mxc_sys_periph_clock_t enum uses enum values that are the offset by 32 and 64 for the perckcn1 register. */
    if (clock > 63) {   // Account for LP peripherals
        clock -= 64;
        MXC_LPGCR->perckcn |= (0x1 << clock);
    } else if (clock > 31) {
        clock -= 32;
        MXC_GCR->perckcn1  |= (0x1 << clock);
    } else {
        MXC_GCR->perckcn  |= (0x1 << clock);
    }

    return E_NO_ERROR;
}

/* ************************************************************************** */
int MXC_SYS_ClockEnable(mxc_sys_periph_clock_t clock)
{
    /* The mxc_sys_periph_clock_t enum uses enum values that are the offset by 32 and 64 for the perckcn1 register. */
    if (clock > 63) {   // Account for LP peripherals
        clock -= 64;
        MXC_LPGCR->perckcn &= ~(0x1 << clock);
    } else if (clock > 31) {
        clock -= 32;
        MXC_GCR->perckcn1  &= ~(0x1 << clock);
    } else {
        MXC_GCR->perckcn  &= ~(0x1 << clock);
    }

    return E_NO_ERROR;
}

/* ************************************************************************** */
int MXC_SYS_RTCClockEnable(void)
{
    // Enable 32k Oscillator
    MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_X32K_EN;
    
    // Check if 32k clock is ready
    if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_X32K_RDY) != E_NO_ERROR) {
        return E_TIME_OUT;
    }
    
    return E_NO_ERROR;
}

/* ************************************************************************** */
int MXC_SYS_RTCClockDisable(void)
{
    // Enable 32k Oscillator
    MXC_GCR->clkcn &= (~MXC_F_GCR_CLKCN_X32K_EN);
    return E_NO_ERROR;
}


/**
 * @brief Disable System Clock Source
 * @param      clock The clock to disable
 * @return     E_NO_ERROR if everything is successful
 */
int MXC_SYS_ClockSourceDisable (mxc_sys_system_clock_t clock) {
    uint32_t current_clock;

    current_clock = MXC_GCR->clkcn & MXC_F_GCR_CLKCN_CLKSEL;

    // Don't turn off the clock we're running on
    if(clock == current_clock) {
        return E_BAD_PARAM;
    }

    switch(clock) {
        case MXC_SYS_CLOCK_HIRC:
            MXC_GCR->clkcn &= ~MXC_F_GCR_CLKCN_HIRC_EN;
            break;
        case MXC_SYS_CLOCK_LIRC8K:        //Always enabled
            break;
        case MXC_SYS_CLOCK_HIRC96M:
            MXC_GCR->clkcn &= ~MXC_F_GCR_CLKCN_HIRC96M_EN;
            break;
        case MXC_SYS_CLOCK_HIRC8M:
            MXC_GCR->clkcn &= ~MXC_F_GCR_CLKCN_HIRC8M_EN;
            break;
        case MXC_SYS_CLOCK_X32K:
            MXC_GCR->clkcn &= ~MXC_F_GCR_CLKCN_X32K_EN;
            break;
        case MXC_SYS_CLOCK_X32M:
            MXC_GCR->clkcn &= ~MXC_F_GCR_CLKCN_X32M_EN;
            break;
        default:
            return E_BAD_PARAM;
    }

    return E_NO_ERROR;
}

/**
 * @brief Enable System Clock Source without switching to it
 * @param      clock The clock to enable
 * @return     E_NO_ERROR if everything is successful
 */
int MXC_SYS_ClockSourceEnable (mxc_sys_system_clock_t clock) {
    switch(clock) {
        case MXC_SYS_CLOCK_HIRC:
            MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC_EN;
            return MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC_RDY);
        case MXC_SYS_CLOCK_LIRC8K:        //Always enabled
            return MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_LIRC8K_RDY);
        case MXC_SYS_CLOCK_HIRC96M:
            MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC96M_EN;
            return MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC96M_RDY);
        case MXC_SYS_CLOCK_HIRC8M:
            MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC8M_EN;
            return MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC8M_RDY);
        case MXC_SYS_CLOCK_X32K:
            MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_X32K_EN;
            return MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_X32K_RDY);
        default:
            return E_BAD_PARAM;
    }

    return E_NO_ERROR;
}

/* ************************************************************************** */
int MXC_SYS_Clock_Select(mxc_sys_system_clock_t clock)
{
    uint32_t current_clock;
    
    // Save the current system clock
    current_clock = MXC_GCR->clkcn & MXC_F_GCR_CLKCN_CLKSEL;
    
    switch (clock) {
        case MXC_SYS_CLOCK_HIRC:
            // Enable HIRC clock
            if (!(MXC_GCR->clkcn & MXC_F_GCR_CLKCN_HIRC_EN)) {
                MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC_EN;
            
                // Check if HIRC clock is ready
                if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC_RDY) != E_NO_ERROR) {
                    return E_TIME_OUT;
                }
            }
            
            // Set HIRC clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_S_GCR_CLKCN_CLKSEL_HIRC);
            
            break;
        case MXC_SYS_CLOCK_LIRC8K:
            // Check if LIRC8K clock is ready
            if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_LIRC8K_RDY) != E_NO_ERROR) {
                return E_TIME_OUT;
            }
            
            // Set LIRC8K clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_S_GCR_CLKCN_CLKSEL_LIRC8K);
            
            break;
        case MXC_SYS_CLOCK_HIRC96M:
            // Enable HIRC96M clock
            if (!(MXC_GCR->clkcn & MXC_F_GCR_CLKCN_HIRC96M_EN)) {
                MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC96M_EN;
            
                // Check if HIRC96M clock is ready
                if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC96M_RDY) != E_NO_ERROR) {
                    return E_TIME_OUT;
                }
            }

            // Set HIRC96M clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_S_GCR_CLKCN_CLKSEL_HIRC96M);
            
            break;
        case MXC_SYS_CLOCK_HIRC8M:
            // Enable HIRC8M clock
            if (!(MXC_GCR->clkcn & MXC_F_GCR_CLKCN_HIRC8M_EN)) {
                MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_HIRC8M_EN;
            
                // Check if HIRC8M clock is ready
                if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_HIRC8M_RDY) != E_NO_ERROR) {
                    return E_TIME_OUT;
                }
            }
            
            // Set HIRC8M clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_S_GCR_CLKCN_CLKSEL_HIRC8M);
            
            break;
        case MXC_SYS_CLOCK_X32M:
            // Enable 32M Oscillator
            if (!(MXC_GCR->clkcn & MXC_F_GCR_CLKCN_X32M_EN)) {
                MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_X32M_EN;
            
                // Check if 32M clock is ready
                if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_X32M_RDY) != E_NO_ERROR) {
                    return E_TIME_OUT;
                }
            }

            // Set 32M clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_F_GCR_CLKCN_X32M_RDY);
            
            break;
        case MXC_SYS_CLOCK_X32K:
            // Enable 32k Oscillator
            if (!(MXC_GCR->clkcn & MXC_F_GCR_CLKCN_X32K_EN)) {
                MXC_GCR->clkcn |= MXC_F_GCR_CLKCN_X32K_EN;
            
                // Check if 32k clock is ready
                if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_X32K_RDY) != E_NO_ERROR) {
                    return E_TIME_OUT;
                }
            }

            // Set 32k clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_F_GCR_CLKCN_X32K_RDY);
            
            break;
        case MXC_SYS_CLOCK_EXTCLK:
            // Set EXT clock as System Clock
            MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, MXC_S_GCR_CLKCN_CLKSEL_EXTCLK);

            break;
        default:
            return E_BAD_PARAM;
    }
    
    // Wait for system clock to be ready
    if (MXC_SYS_Clock_Timeout(MXC_F_GCR_CLKCN_CKRDY) != E_NO_ERROR) {
    
        // Restore the old system clock if timeout
        MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_CLKSEL, current_clock);
        
        return E_TIME_OUT;
    }
    
    // Update the system core clock
    SystemCoreClockUpdate();
    
    return E_NO_ERROR;
}

/**
 * @brief Select the system clock divider.
 * @param clock     Enumeration for desired system clock divider.
 */
void MXC_SYS_SetClockDiv(mxc_sys_system_clock_div_t div) {
    MXC_SETFIELD(MXC_GCR->clkcn, MXC_F_GCR_CLKCN_PSC, div);

    // Update the system core clock
    SystemCoreClockUpdate();
}

/* ************************************************************************** */
int MXC_SYS_Clock_Timeout(uint32_t ready)
{
    // Start timeout, wait for ready
    MXC_DelayAsync(SYS_CLOCK_TIMEOUT, NULL);
    do {
        if (MXC_GCR->clkcn & ready) {
            MXC_DelayAbort();
            return E_NO_ERROR;
        }
    } while (MXC_DelayCheck() == E_BUSY);
    
    return E_TIME_OUT;
}

/* ************************************************************************** */
mxc_sys_system_clock_div_t MXC_SYS_GetClockDiv (void)
{
    return (MXC_GCR->clkcn & MXC_F_GCR_CLKCN_PSC);
}

/* ************************************************************************** */
int MXC_SYS_Reset_Periph (mxc_sys_reset_t reset)
{
    /* The mxc_sys_reset_t enum uses enum values that are the offset by 32 and 64 for the rst register. */
    if (reset > 63) {   // Account for LP peripherals
        reset -= 64;
        MXC_LPGCR->rstr = (0x1 << reset);
    } else if (reset > 31) {
        reset -= 32;
        MXC_GCR->rstr1  = (0x1 << reset);
    } else {
        MXC_GCR->rstr  = (0x1 << reset);
    }

    return E_NO_ERROR;
}

/* ************************************************************************** */
void MXC_SYS_RISCVRun(void)
{
    /* Disable the the RSCV */
    MXC_GCR->perckcn1 |= MXC_F_GCR_PERCKCN1_CPU1D;

    /* Set the interrupt vector base address */
    MXC_FCR->urvbootaddr = (uint32_t)&_binary_riscv_bin_start;

    /* Power up the RSCV */
    MXC_GCR->perckcn1 &= ~(MXC_F_GCR_PERCKCN1_CPU1D);

    /* CPU1 reset */
    MXC_GCR->rstr1 |= MXC_F_GCR_RSTR1_CPU1;
}

/* ************************************************************************** */
void MXC_SYS_RISCVShutdown(void)
{
    /* Disable the the RSCV */
    MXC_GCR->perckcn1 |= MXC_F_GCR_PERCKCN1_CPU1D;
}

/* ************************************************************************** */
uint32_t MXC_SYS_RiscVClockRate(void)
{
    // If in LPM mode and the PCLK is selected as the RV32 clock source,
    if(((MXC_GCR->pmr & MXC_F_GCR_PMR_MODE) == MXC_S_GCR_PMR_MODE_LPM) && 
       ((MXC_PWRSEQ->lpcn & MXC_F_PWRSEQ_LPCN_LPMCLKSEL) == 0)) {
        return SystemCoreClock / 2;
    } else {
        return ISO_FREQ;
    }
}

/**@} end of mxc_sys */
